﻿USE [COWS]
GO
_CreateObject 'SP','dbo','getOrderBasic'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ================================================================
-- Author:		Lakshmi Kadiyala
-- Create date: 17th Sep 2011
-- Description:	Returns basic details for given order
-- kh946640 03/22/18 COWS DB Restructuring as columns have been moved from fsa_ordr->fsa_ordr_cpe_line_item table for DualPort project(PJ020783 - CR93)
-- ================================================================

ALTER PROCEDURE [dbo].[getOrderBasic]
	@OrderID INT 	
AS
BEGIN
SET NOCOUNT ON;

BEGIN TRY

DECLARE @CategoryID SMALLINT
DECLARE @OrderBasic TABLE
(
	ORDR_ID INT,
	ORDR_CAT_ID SMALLINT,
	ORDR_LBL_1 VARCHAR(10),
	ORDR_VAL_1 VARCHAR(25),
	INSTL_VNDR_CD VARCHAR(50),
	VNDR_VPN_CD VARCHAR(50),
	CXR_ACCS_CD VARCHAR(5),
	PROD_TYPE_ID SMALLINT,
	PROD_TYPE_DES VARCHAR(100),
	ORDR_TYPE_ID SMALLINT,
	ORDR_TYPE_DES VARCHAR(133),
	PLTFRM_CD VARCHAR(2),
	PLTFRM_NME VARCHAR(50)
)

SELECT @CategoryId = ORDR_CAT_ID
FROM dbo.ORDR WITH (NOLOCK)
WHERE ORDR_ID = @OrderID

IF(@CategoryID IN (1,5))
BEGIN
	INSERT INTO @OrderBasic
	SELECT TOP 1
		IPL.ORDR_ID,
		OD.ORDR_CAT_ID,
		'CTN',
		IPL.ORDR_ID,
		LV.VNDR_CD,
		LV.VNDR_NME,
		'',
		PT.PROD_TYPE_ID,
		PT.PROD_TYPE_DES,
		OT.ORDR_TYPE_ID,
		OT.ORDR_TYPE_DES,
		LP.PLTFRM_CD,
		LP.PLTFRM_NME
	FROM				dbo.IPL_ORDR		IPL WITH (NOLOCK)
		INNER JOIN		dbo.LK_PROD_TYPE	PT 	WITH (NOLOCK) ON IPL.PROD_TYPE_ID	= PT.PROD_TYPE_ID
		INNER JOIN		dbo.LK_ORDR_TYPE	OT 	WITH (NOLOCK) ON IPL.ORDR_TYPE_ID	= OT.ORDR_TYPE_ID
		INNER JOIN		dbo.ORDR			OD 	WITH (NOLOCK) ON IPL.ORDR_ID		= OD.ORDR_ID
		LEFT OUTER JOIN dbo.LK_PLTFRM		LP 	WITH (NOLOCK) ON OD.PLTFRM_CD		= LP.PLTFRM_CD
		LEFT JOIN		[dbo].[VNDR_ORDR]	VO	WITH (NOLOCK) ON VO.ORDR_ID		= IPL.ORDR_ID  
		INNER JOIN		[dbo].[VNDR_FOLDR]	VF	WITH (NOLOCK) ON VO.VNDR_FOLDR_ID		= VF.VNDR_FOLDR_ID
		INNER JOIN		[dbo].[LK_VNDR]		LV	WITH (NOLOCK) ON VF.VNDR_CD				= LV.VNDR_CD
	WHERE IPL.ORDR_ID = @OrderID	
END
ELSE IF (@CategoryID = 2 OR @CategoryID = 6)
BEGIN
	INSERT INTO @OrderBasic
	SELECT
		FS.ORDR_ID,
		OD.ORDR_CAT_ID,
		'FTN',
		FS.FTN,
		FS.INSTL_VNDR_CD,
		FS.VNDR_VPN_CD,
		CPED.CXR_ACCS_CD,
		PT.PROD_TYPE_ID,
		PT.PROD_TYPE_DES,
		CASE ISNULL(FS.ORDR_SUB_TYPE_CD, '')	WHEN	'INST'		THEN	1
												WHEN	'HCDN'		THEN	3
												WHEN	'COLODN'	THEN	3
												WHEN	'HCUP'		THEN	2
												WHEN	'COLOUP'	THEN	2
												WHEN	'HCMV'		THEN	4
												WHEN	'COLOMV'	THEN	4
												WHEN	'CPEHCMV'	THEN	4
												WHEN	'CPEREMV'	THEN	4
												ELSE	OT.ORDR_TYPE_ID
		END,
		CASE ISNULL(FS.ORDR_SUB_TYPE_CD, '')	WHEN	'INST'		THEN	OT.ORDR_TYPE_DES
												WHEN	'HCDN'		THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'COLODN'	THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'HCUP'		THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'COLOUP'	THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'HCMV'		THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'COLOMV'	THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'CPEHCMV'	THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												WHEN	'CPEREMV'	THEN	OST.ORDR_SUB_TYPE_DES + ' - ' + OT.ORDR_TYPE_DES
												ELSE	OT.ORDR_TYPE_DES
		END,
		LP.PLTFRM_CD,
		LP.PLTFRM_NME
	FROM				dbo.FSA_ORDR			FS	WITH (NOLOCK)
		INNER JOIN		dbo.LK_PROD_TYPE		PT	WITH (NOLOCK) ON FS.PROD_TYPE_CD		= PT.FSA_PROD_TYPE_CD
		INNER JOIN		dbo.LK_ORDR_TYPE		OT	WITH (NOLOCK) ON FS.ORDR_TYPE_CD		= OT.FSA_ORDR_TYPE_CD
		INNER JOIN		dbo.ORDR				OD	WITH (NOLOCK) ON FS.ORDR_ID				= OD.ORDR_ID
		LEFT OUTER JOIN dbo.LK_PLTFRM			LP	WITH (NOLOCK) ON OD.PLTFRM_CD			= LP.PLTFRM_CD
		LEFT OUTER JOIN dbo.LK_ORDR_SUB_TYPE	OST WITH (NOLOCK) ON FS.ORDR_SUB_TYPE_CD	= OST.ORDR_SUB_TYPE_CD
		LEFT OUTER JOIN [dbo].[ORDR_ADR] OA WITH (NOLOCK) ON FS.ORDR_ID = OA.ORDR_ID AND OA.CIS_LVL_TYPE = 'H5'
		LEFT JOIN	dbo.FSA_ORDR_CPE_LINE_ITEM CPED WITH (NOLOCK) ON FS.ORDR_ID = CPED.ORDR_ID	
	WHERE FS.ORDR_ID = @OrderID

END
ELSE IF(@CategoryID = 4)
BEGIN
	INSERT INTO @OrderBasic
	SELECT TOP 1
		NCCO.ORDR_ID,
		OD.ORDR_CAT_ID,
		'CTN',
		NCCO.ORDR_ID,
		LV.VNDR_CD,
		LV.VNDR_NME,
		'',
		PT.PROD_TYPE_ID,
		PT.PROD_TYPE_DES,
		OT.ORDR_TYPE_ID,
		OT.ORDR_TYPE_DES,
		LP.PLTFRM_CD,
		LP.PLTFRM_NME
	FROM				dbo.NCCO_ORDR		NCCO WITH (NOLOCK)
		INNER JOIN		dbo.LK_PROD_TYPE	PT 	WITH (NOLOCK) ON NCCO.PROD_TYPE_ID	= PT.PROD_TYPE_ID
		INNER JOIN		dbo.LK_ORDR_TYPE	OT 	WITH (NOLOCK) ON NCCO.ORDR_TYPE_ID	= OT.ORDR_TYPE_ID
		INNER JOIN		dbo.ORDR			OD 	WITH (NOLOCK) ON NCCO.ORDR_ID		= OD.ORDR_ID
		LEFT OUTER JOIN dbo.LK_PLTFRM		LP 	WITH (NOLOCK) ON OD.PLTFRM_CD		= LP.PLTFRM_CD
		LEFT JOIN		[dbo].[VNDR_ORDR]	VO	WITH (NOLOCK) ON VO.ORDR_ID		= NCCO.ORDR_ID  
		INNER JOIN		[dbo].[VNDR_FOLDR]	VF	WITH (NOLOCK) ON VO.VNDR_FOLDR_ID		= VF.VNDR_FOLDR_ID
		INNER JOIN		[dbo].[LK_VNDR]		LV	WITH (NOLOCK) ON VF.VNDR_CD				= LV.VNDR_CD
	WHERE NCCO.ORDR_ID = @OrderID	
END

SELECT * FROM @OrderBasic

END TRY
BEGIN CATCH
	EXEC [dbo].[insertErrorInfo]
END CATCH
END
GO